#include <iostream>
#include <cmath>

using namespace std;

int main()
{
	freopen("mirage.in","r",stdin);
	freopen("mirage.out","w",stdout);
	double Ag[4];
	double Bg[4];
	cin >> Ag[0] >> Ag[1] >> Ag[2] >> Ag[3]
		>> Bg[0] >> Bg[1] >> Bg[2] >> Bg[3];
	int Ad,Bd;
	cin >> Ad >> Bd;
	double Ac=(double) Ad / (Ad+Bd);
	double Bc=(double) Bd / (Ad+Bd);
	double Anormal=(1-Ag[0])*(1-Ag[1])*(1-Ag[2])*(1-Ag[3]);
	double Bnormal=(1-Bg[0])*(1-Bg[1])*(1-Bg[2])*(1-Bg[3]);
	double ABnormal=Anormal*Bnormal;
	double ACrash=1-Anormal;
	double BCrash=1-Bnormal;
	double ABCrash=ACrash*BCrash;
	double Draw=ABCrash;
	double AnBc=Anormal*BCrash; //A win
	double AcBn=Bnormal*ACrash; //B win
	double Awin=AnBc + ABnormal*Ac;
	double Bwin=AcBn + ABnormal*Bc;
	printf("%.2lf %.2lf %.2lf\n",Awin,Bwin,Draw);
	int N;
	cin >> N;
	double Total=0,AT=0,BT=0,Avg=1,Z;
	Z=1.0/N;
	for (int i=1;i<=N;i++)
	{
		int a;
		double V,C;
		scanf("%lf%d",&V,&a);
		if (a==0)
			AT+=V;
		else
			BT+=V;
		C=pow(V,Z);
		Total+=V;
		Avg*=C;
	}
	double Za=Awin*(Total-(AT*2));
	double Zb=Bwin*(Total-(BT*2));
	double Zp=Draw*(Total-(Avg*N));
	double E=Za+Zb+Zp;
	printf("%.2lf",E);
	return 0;
}