#include <iostream>
#define MAX 1000001
#define MAXM 101
using namespace std;

typedef struct
{
	int from;
	int add;
}good;

int N,M;
int C1,C2,Ans1,Ans2;
int Cost1[MAXM],Cost2[MAXM],Wealth1[MAXM],Wealth2[MAXM],K1[MAXM],K2[MAXM];
int F[MAX],B1[MAXM],B2[MAXM],Buy[MAXM];
good G[MAX];

void init()
{
	int i,a,b;
	freopen("goblin.in","r",stdin);
	freopen("goblin.out","w",stdout);
	cin >> N >> M;
	for (i=1;i<=M;i++)
	{
		scanf("%d%d",&a,&b);
		if (a<b)
		{
			++C1;
			Cost1[C1]=a;
			Wealth1[C1]=b-a;
			K1[C1]=i;
		}
		else if(a>b)
		{
			++C2;
			Cost2[C2]=b;
			Wealth2[C2]=a-b;
			K2[C2]=i;
		}
	}
}

int dynamic(int N,int M,int *Cost,int *Wealth,int *Buy)
{
	int i,k,max;
	memset(F,0,sizeof(F));
	for (i=1;i<=N;i++)
	{
		max=0;
		for (k=1;k<=M;k++)
		{
			if (i-Cost[k]>=0 && F[ i-Cost[k] ] + Wealth[k] > max)
			{
				max=F[ i-Cost[k] ] + Wealth[k];
				G[i].from=i-Cost[k];
				G[i].add=k;
			}
		}
		F[i]=max;
	}
	for (i=N;G[i].add;i=G[i].from)
	{
		Buy[ G[i].add ]++;
	}
	return F[N];
}

void solve()
{
	int i;
	Ans1=dynamic(N,C1,Cost1,Wealth1,B1);
	Ans2=dynamic(N+Ans1,C2,Cost2,Wealth2,B2);
	cout << Ans1 + Ans2 << endl;
	for (i=1;i<=C1;i++)
	{
		Buy[K1[i]]+=B1[i];
	}
	for (i=1;i<=C2;i++)
	{
		Buy[K2[i]]-=B2[i];
	}
	for (i=1;i<=M;i++)
	{
		if (Buy[i]==0)
			printf("Buy 0\n");
		else if (Buy[i]>0)
			printf("Buy %d from Alliance\n",Buy[i]);
		else
			printf("Buy %d from Horde\n",-Buy[i]);
	}
}

int main()
{
	init();
	solve();
	return 0;
}